seo:
  title: How eslint-plugin-vue improved our code reviews
  description: >-
    A few months ago we felt the need to build a style guide for Vue and now are
    using eslint-vue-plugin, which is saving us time in our code reviews.
  ogTitle: How eslint-plugin-vue improved our code reviews
  ogDescription: >-
    A few months ago we felt the need to build a style guide for Vue and now are
    using eslint-vue-plugin, which is saving us time in our code reviews.
  noIndex: false
  ogImage: images/blog/hero-images/code_cover_image.jpg
  ogUrl: https://about.gitlab.com/blog/how-we-added-eslint-into-vue
  ogSiteName: https://about.gitlab.com
  ogType: article
  canonicalUrls: https://about.gitlab.com/blog/how-we-added-eslint-into-vue
  schema: |2-

                            {
            "@context": "https://schema.org",
            "@type": "Article",
            "headline": "How eslint-plugin-vue improved our code reviews",
            "author": [{"@type":"Person","name":"Filipa Lacerda"}],
            "datePublished": "2018-02-13",
          }

content:
  title: How eslint-plugin-vue improved our code reviews
  description: >-
    A few months ago we felt the need to build a style guide for Vue and now are
    using eslint-vue-plugin, which is saving us time in our code reviews.
  authors:
    - Filipa Lacerda
  heroImage: images/blog/hero-images/code_cover_image.jpg
  date: '2018-02-13'
  body: >


    We've (finally) integrated
    [eslint-plugin-vue](https://github.com/vuejs/eslint-plugin-vue) successfully
    into our codebase!


    <!-- more -->


    When we [added
    Vue](https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/5845) to our
    codebase back in April 2016,
    [eslint-plugin-vue](https://github.com/vuejs/eslint-plugin-vue) did not yet
    [exist](https://github.com/vuejs/eslint-plugin-vue/commit/6a3a6db540e823b51af1e02950896ac9c2b49219)
    and we had not yet started using [eslint](https://eslint.org/) at all.


    One of the things I love the most about GitLab being an open source tool is
    that anyone can contribute! [Winnie Hellmann](https://gitlab.com/winh), who
    has since joined the team, did this amazing work [adding
    eslint](https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/5445) as a
    community contribution. Thanks Winnie! 🙇‍


    ## The start of a style guide


    As our Vue codebase grew from a few features to quite a large usage ([issue
    boards](https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/5554),
    [environments](https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/8954),
    [cycle
    analytics](https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/7366),
    [pipelines](https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/10878))
    we noticed that each of our Vue apps followed a different style. At that
    time we felt the need to [document how to architecture a Vue
    application](https://gitlab.com/gitlab-org/gitlab-ce/merge_requests/8866) to
    ensure a consistent codebase. Once we defined and documented how to use the
    component system and Flux architecture [with our
    codebase](https://docs.gitlab.com/ee/development/fe_guide/vue.html#vue-architecture),
    we noticed that our Vue code also differed in very small things, such as
    indentation or the order we declared the methods. These inconsistencies,
    although small, increased the complexity of the review process and for
    maintaining a healthy codebase.


    With the goal of decreasing the time we spent reviewing Vue code and
    debating on each of these aspects, and because at the time there wasn't an
    official Vue style guide, [we started our
    own](https://gitlab.com/gitlab-org/gitlab-ce/commit/8c3bdc853a5237a3bef6e26fcf22132db7e8bd9c)!
    You can check out our documentation [here](https://docs.gitlab.com/e
    e/development/fe_guide/style_guide_js.html#vue-js). As the Vue community
    grew, the need for an official style guide and for an eslint plugin for Vue
    grew with it. Thanks to the wonderful team [Michał
    Sajnóg](https://github.com/michalsnik), [Toru
    Nagashima](https://github.com/mysticatea),
    [Armano](https://github.com/armano2) and [Chris
    Fritz](https://github.com/chrisvfritz) leading the development of such a
    tool, we are now able to use it in production! And we even got to act as
    source of [inspiration for the official
    one](https://github.com/vuejs/eslint-plugin-vue/issues/77#issuecomment-315834845)
    ❤


    ## Adding eslint-vue-plugin


    After [waiting a couple of
    months](https://gitlab.com/gitlab-org/gitlab-ce/issues/34312) for a stable
    version of [eslint-plugin-vue](https://github.com/vuejs/eslint-plugin-vue),
    we finally gave it a try once version
    [4.0.0](https://github.com/vuejs/eslint-plugin-vue/releases/tag/v4.0.0) was
    released.


    ![EE
    Conflicts](https://about.gitlab.com/images/eslint-vue-plugin/eslint-conflicts-team-help.png
    "EE Conflicts"){: .shadow}


    *<small>Frontend team working together to resolve all the vue eslint
    problems</small>*


    It took a couple of days to fix all the problems eslint identified in our
    code, but we were able to successfully add it and thanks to a huge team
    effort, the second row of conflicts was solved very quickly. Thanks again
    Luke, Eric, Kushal and José!


    Now our review process is even faster, we don't have to manually check for
    the style guide rules anymore! 🎉


    [Cover image](https://pixabay.com/en/computer-computer-code-screen-1209641/)
    by [Free-Photos](https://pixabay.com/en/users/Free-Photos-242387/) is
    licensed under [CC0 1.0](https://creativecommons.org/publicdomain/zero/1.0/)

    {: .note}
  category: Engineering
  tags:
    - inside GitLab
    - frontend
config:
  slug: how-we-added-eslint-into-vue
  featured: false
  template: BlogPost
